diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_lib.c openssl-1.0.0q/crypto/x509v3/v3_lib.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_lib.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_lib.c	2017-04-25 16:23:40.879798686 +0200
@@ -57,17 +57,27 @@
  */
 /* X509 v3 extension utilities */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/conf.h>
 #include <openssl/x509v3.h>
 
 #include "ext_dat.h"
 
+#ifndef OPERA_SMALL_VERSION
+#ifdef _NO_GLOBALS_
+extern STACK_OF(X509V3_EXT_METHOD) *g_ext_list_addr();
+#define ext_list (*g_ext_list_addr())
+#else
 static STACK_OF(X509V3_EXT_METHOD) *ext_list = NULL;
+#endif
+#endif
 
 static int ext_cmp(const X509V3_EXT_METHOD * const *a,
 		const X509V3_EXT_METHOD * const *b);
+#ifndef OPERA_SMALL_VERSION
 static void ext_list_free(X509V3_EXT_METHOD *ext);
 
 int X509V3_EXT_add(X509V3_EXT_METHOD *ext)
@@ -82,6 +92,7 @@
 	}
 	return 1;
 }
+#endif
 
 static int ext_cmp(const X509V3_EXT_METHOD * const *a,
 		   const X509V3_EXT_METHOD * const *b)
@@ -98,15 +109,22 @@
 {
 	X509V3_EXT_METHOD tmp;
 	const X509V3_EXT_METHOD *t = &tmp, * const *ret;
+#ifndef OPERA_SMALL_VERSION
 	int idx;
+#endif
 	if(nid < 0) return NULL;
 	tmp.ext_nid = nid;
 	ret = OBJ_bsearch_ext(&t, standard_exts, STANDARD_EXTENSION_COUNT);
 	if(ret) return *ret;
+#ifndef OPERA_SMALL_VERSION
 	if(!ext_list) return NULL;
 	idx = sk_X509V3_EXT_METHOD_find(ext_list, &tmp);
 	if(idx == -1) return NULL;
 	return sk_X509V3_EXT_METHOD_value(ext_list, idx);
+#else
+	return NULL;
+#endif
+
 }
 
 const X509V3_EXT_METHOD *X509V3_EXT_get(X509_EXTENSION *ext)
@@ -117,6 +135,7 @@
 }
 
 
+#ifndef OPERA_SMALL_VERSION
 int X509V3_EXT_add_list(X509V3_EXT_METHOD *extlist)
 {
 	for(;extlist->ext_nid!=-1;extlist++) 
@@ -162,6 +181,7 @@
 {
 	return 1;
 }
+#endif
 
 /* Return an extension internal structure */
 
@@ -236,6 +256,7 @@
  * 'value' arguments (if relevant) are the extensions internal structure.
  */
 
+#if !defined OPERA_SMALL_VERSION || !defined OPENSSL_NO_OCSP
 int X509V3_add1_i2d(STACK_OF(X509_EXTENSION) **x, int nid, void *value,
 					int crit, unsigned long flags)
 {
@@ -305,5 +326,6 @@
 		X509V3err(X509V3_F_X509V3_ADD1_I2D, errcode);
 	return 0;
 }
+#endif /* OPERA_SMALL_VERSION */
 
 IMPLEMENT_STACK_OF(X509V3_EXT_METHOD)
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_ncons.c openssl-1.0.0q/crypto/x509v3/v3_ncons.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_ncons.c	2015-01-15 15:54:59.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_ncons.c	2017-04-25 16:23:40.880798255 +0200
@@ -56,20 +56,21 @@
  *
  */
 
-
-#include <stdio.h>
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/conf.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
+#ifndef OPERA_SMALL_VERSION
 static void *v2i_NAME_CONSTRAINTS(const X509V3_EXT_METHOD *method,
 				  X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *nval);
+#endif
 static int i2r_NAME_CONSTRAINTS(const X509V3_EXT_METHOD *method, 
 				void *a, BIO *bp, int ind);
 static int do_i2r_name_constraints(const X509V3_EXT_METHOD *method,
 				   STACK_OF(GENERAL_SUBTREE) *trees,
-				   BIO *bp, int ind, char *name);
+				   BIO *bp, int ind, const char *name);
 static int print_nc_ipadd(BIO *bp, ASN1_OCTET_STRING *ip);
 
 static int nc_match(GENERAL_NAME *gen, NAME_CONSTRAINTS *nc);
@@ -79,33 +80,36 @@
 static int nc_email(ASN1_IA5STRING *sub, ASN1_IA5STRING *eml);
 static int nc_uri(ASN1_IA5STRING *uri, ASN1_IA5STRING *base);
 
-const X509V3_EXT_METHOD v3_name_constraints = {
+CONST_X509V3_EXT_METHOD_item(v3_name_constraints,
 	NID_name_constraints, 0,
 	ASN1_ITEM_ref(NAME_CONSTRAINTS),
 	0,0,0,0,
 	0,0,
-	0, v2i_NAME_CONSTRAINTS,
+	0, OPERA_V2I_DECLARE(v2i_NAME_CONSTRAINTS),
 	i2r_NAME_CONSTRAINTS,0,
 	NULL
-};
+)
 
-ASN1_SEQUENCE(GENERAL_SUBTREE) = {
-	ASN1_SIMPLE(GENERAL_SUBTREE, base, GENERAL_NAME),
-	ASN1_IMP_OPT(GENERAL_SUBTREE, minimum, ASN1_INTEGER, 0),
+ASN1_SEQUENCE(GENERAL_SUBTREE) 
+	ASN1_SIMPLE(GENERAL_SUBTREE, base, GENERAL_NAME)
+	ASN1_IMP_OPT(GENERAL_SUBTREE, minimum, ASN1_INTEGER, 0)
 	ASN1_IMP_OPT(GENERAL_SUBTREE, maximum, ASN1_INTEGER, 1)
-} ASN1_SEQUENCE_END(GENERAL_SUBTREE)
+ASN1_SEQUENCE_END(GENERAL_SUBTREE)
 
-ASN1_SEQUENCE(NAME_CONSTRAINTS) = {
+ASN1_SEQUENCE(NAME_CONSTRAINTS) 
 	ASN1_IMP_SEQUENCE_OF_OPT(NAME_CONSTRAINTS, permittedSubtrees,
-							GENERAL_SUBTREE, 0),
+							GENERAL_SUBTREE, 0)
 	ASN1_IMP_SEQUENCE_OF_OPT(NAME_CONSTRAINTS, excludedSubtrees,
-							GENERAL_SUBTREE, 1),
-} ASN1_SEQUENCE_END(NAME_CONSTRAINTS)
+							GENERAL_SUBTREE, 1)
+ASN1_SEQUENCE_END(NAME_CONSTRAINTS)
 	
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_ALLOC_FUNCTIONS(GENERAL_SUBTREE)
+#endif
 IMPLEMENT_ASN1_ALLOC_FUNCTIONS(NAME_CONSTRAINTS)
 
+#ifndef OPERA_SMALL_VERSION
 static void *v2i_NAME_CONSTRAINTS(const X509V3_EXT_METHOD *method,
 				  X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *nval)
 	{
@@ -158,14 +162,13 @@
 
 	return NULL;
 	}
-			
-
+#endif
 	
 
 static int i2r_NAME_CONSTRAINTS(const X509V3_EXT_METHOD *method, void *a,
 				BIO *bp, int ind)
 	{
-	NAME_CONSTRAINTS *ncons = a;
+	NAME_CONSTRAINTS *ncons = (NAME_CONSTRAINTS *) a;
 	do_i2r_name_constraints(method, ncons->permittedSubtrees,
 					bp, ind, "Permitted");
 	do_i2r_name_constraints(method, ncons->excludedSubtrees,
@@ -175,7 +178,7 @@
 
 static int do_i2r_name_constraints(const X509V3_EXT_METHOD *method,
 				   STACK_OF(GENERAL_SUBTREE) *trees,
-				   BIO *bp, int ind, char *name)
+				   BIO *bp, int ind, const char *name)
 	{
 	GENERAL_SUBTREE *tree;
 	int i;
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_ocsp.c openssl-1.0.0q/crypto/x509v3/v3_ocsp.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_ocsp.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_ocsp.c	2017-04-25 16:23:40.881798102 +0200
@@ -58,74 +58,81 @@
 
 #ifndef OPENSSL_NO_OCSP
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/conf.h>
 #include <openssl/asn1.h>
 #include <openssl/ocsp.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 /* OCSP extensions and a couple of CRL entry extensions
  */
 
+#ifndef OPERA_SMALL_VERSION
 static int i2r_ocsp_crlid(const X509V3_EXT_METHOD *method, void *nonce,
 			  BIO *out, int indent);
 static int i2r_ocsp_acutoff(const X509V3_EXT_METHOD *method, void *nonce,
 			    BIO *out, int indent);
 static int i2r_object(const X509V3_EXT_METHOD *method, void *obj, BIO *out,
 		      int indent);
+#endif // !OPERA_SMALL_VERSION
 
 static void *ocsp_nonce_new(void);
 static int i2d_ocsp_nonce(void *a, unsigned char **pp);
 static void *d2i_ocsp_nonce(void *a, const unsigned char **pp, long length);
 static void ocsp_nonce_free(void *a);
+
+#ifndef OPERA_SMALL_VERSION
 static int i2r_ocsp_nonce(const X509V3_EXT_METHOD *method, void *nonce,
 			  BIO *out, int indent);
-
 static int i2r_ocsp_nocheck(const X509V3_EXT_METHOD *method,
 			    void *nocheck, BIO *out, int indent);
 static void *s2i_ocsp_nocheck(const X509V3_EXT_METHOD *method, X509V3_CTX *ctx,
 			      const char *str);
 static int i2r_ocsp_serviceloc(const X509V3_EXT_METHOD *method, void *in,
 			       BIO *bp, int ind);
+#endif // !OPERA_SMALL_VERSION
 
-const X509V3_EXT_METHOD v3_ocsp_crlid = {
+CONST_X509V3_EXT_METHOD_item(v3_ocsp_crlid,
 	NID_id_pkix_OCSP_CrlID, 0, ASN1_ITEM_ref(OCSP_CRLID),
 	0,0,0,0,
 	0,0,
 	0,0,
-	i2r_ocsp_crlid,0,
+	OPERA_I2R_DECLARE(i2r_ocsp_crlid),0,
 	NULL
-};
+)
 
-const X509V3_EXT_METHOD v3_ocsp_acutoff = {
+CONST_X509V3_EXT_METHOD_item(v3_ocsp_acutoff,
 	NID_id_pkix_OCSP_archiveCutoff, 0, ASN1_ITEM_ref(ASN1_GENERALIZEDTIME),
 	0,0,0,0,
 	0,0,
 	0,0,
-	i2r_ocsp_acutoff,0,
+	OPERA_I2R_DECLARE(i2r_ocsp_acutoff),0,
 	NULL
-};
+)
 
-const X509V3_EXT_METHOD v3_crl_invdate = {
+CONST_X509V3_EXT_METHOD_item(v3_crl_invdate,
 	NID_invalidity_date, 0, ASN1_ITEM_ref(ASN1_GENERALIZEDTIME),
 	0,0,0,0,
 	0,0,
 	0,0,
-	i2r_ocsp_acutoff,0,
+	OPERA_I2R_DECLARE(i2r_ocsp_acutoff),0,
 	NULL
-};
+)
 
-const X509V3_EXT_METHOD v3_crl_hold = {
+CONST_X509V3_EXT_METHOD_item(v3_crl_hold,
 	NID_hold_instruction_code, 0, ASN1_ITEM_ref(ASN1_OBJECT),
 	0,0,0,0,
 	0,0,
 	0,0,
-	i2r_object,0,
+	OPERA_I2R_DECLARE(i2r_object),0,
 	NULL
-};
+)
 
-const X509V3_EXT_METHOD v3_ocsp_nonce = {
+CONST_X509V3_EXT_METHOD_item(v3_ocsp_nonce,
 	NID_id_pkix_OCSP_Nonce, 0, NULL,
 	ocsp_nonce_new,
 	ocsp_nonce_free,
@@ -133,32 +140,33 @@
 	i2d_ocsp_nonce,
 	0,0,
 	0,0,
-	i2r_ocsp_nonce,0,
+	OPERA_I2R_DECLARE(i2r_ocsp_nonce),0,
 	NULL
-};
+)
 
-const X509V3_EXT_METHOD v3_ocsp_nocheck = {
+CONST_X509V3_EXT_METHOD_item(v3_ocsp_nocheck ,
 	NID_id_pkix_OCSP_noCheck, 0, ASN1_ITEM_ref(ASN1_NULL),
 	0,0,0,0,
-	0,s2i_ocsp_nocheck,
+	0,OPERA_S2I_DECLARE(s2i_ocsp_nocheck),
 	0,0,
-	i2r_ocsp_nocheck,0,
+	OPERA_I2R_DECLARE(i2r_ocsp_nocheck),0,
 	NULL
-};
+)
 
-const X509V3_EXT_METHOD v3_ocsp_serviceloc = {
+CONST_X509V3_EXT_METHOD_item(v3_ocsp_serviceloc,
 	NID_id_pkix_OCSP_serviceLocator, 0, ASN1_ITEM_ref(OCSP_SERVICELOC),
 	0,0,0,0,
 	0,0,
 	0,0,
-	i2r_ocsp_serviceloc,0,
+	OPERA_I2R_DECLARE(i2r_ocsp_serviceloc),0,
 	NULL
-};
+)
 
+#ifndef OPERA_SMALL_VERSION
 static int i2r_ocsp_crlid(const X509V3_EXT_METHOD *method, void *in, BIO *bp,
 			  int ind)
 {
-	OCSP_CRLID *a = in;
+	OCSP_CRLID *a = (OCSP_CRLID *) in;
 	if (a->crlUrl)
 	        {
 		if (BIO_printf(bp, "%*scrlUrl: ", ind, "") <= 0) goto err;
@@ -198,6 +206,7 @@
 	if(i2a_ASN1_OBJECT(bp, oid) <= 0) return 0;
 	return 1;
 }
+#endif
 
 /* OCSP nonce. This is needs special treatment because it doesn't have
  * an ASN1 encoding at all: it just contains arbitrary data.
@@ -210,9 +219,9 @@
 
 static int i2d_ocsp_nonce(void *a, unsigned char **pp)
 {
-	ASN1_OCTET_STRING *os = a;
+	ASN1_OCTET_STRING *os = (ASN1_OCTET_STRING *) a;
 	if(pp) {
-		memcpy(*pp, os->data, os->length);
+		op_memcpy(*pp, os->data, os->length);
 		*pp += os->length;
 	}
 	return os->length;
@@ -221,7 +230,7 @@
 static void *d2i_ocsp_nonce(void *a, const unsigned char **pp, long length)
 {
 	ASN1_OCTET_STRING *os, **pos;
-	pos = a;
+	pos = (ASN1_OCTET_STRING **) a;
 	if(!pos || !*pos) os = ASN1_OCTET_STRING_new();
 	else os = *pos;
 	if(!ASN1_OCTET_STRING_set(os, *pp, length)) goto err;
@@ -242,11 +251,12 @@
 	M_ASN1_OCTET_STRING_free(a);
 }
 
+#ifndef OPERA_SMALL_VERSION
 static int i2r_ocsp_nonce(const X509V3_EXT_METHOD *method, void *nonce,
 			  BIO *out, int indent)
 {
 	if(BIO_printf(out, "%*s", indent, "") <= 0) return 0;
-	if(i2a_ASN1_STRING(out, nonce, V_ASN1_OCTET_STRING) <= 0) return 0;
+	if(i2a_ASN1_STRING(out, (ASN1_OCTET_STRING *) nonce, V_ASN1_OCTET_STRING) <= 0) return 0;
 	return 1;
 }
 
@@ -268,7 +278,7 @@
 			       BIO *bp, int ind)
         {
 	int i;
-	OCSP_SERVICELOC *a = in;
+	OCSP_SERVICELOC *a = (OCSP_SERVICELOC *) in;
 	ACCESS_DESCRIPTION *ad;
 
         if (BIO_printf(bp, "%*sIssuer: ", ind, "") <= 0) goto err;
@@ -286,4 +296,6 @@
 err:
 	return 0;
 	}
+#endif // OPERA_SMALL_VERSION
+
 #endif
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_pci.c openssl-1.0.0q/crypto/x509v3/v3_pci.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_pci.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_pci.c	2017-04-25 16:23:40.882797671 +0200
@@ -34,26 +34,29 @@
  * SUCH DAMAGE.
  */
 
-#include <stdio.h>
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include <openssl/conf.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
+#ifndef OPERA_SMALL_VERSION
 static int i2r_pci(X509V3_EXT_METHOD *method, PROXY_CERT_INFO_EXTENSION *ext,
 	BIO *out, int indent);
 static PROXY_CERT_INFO_EXTENSION *r2i_pci(X509V3_EXT_METHOD *method,
 	X509V3_CTX *ctx, char *str);
+#endif
 
-const X509V3_EXT_METHOD v3_pci =
-	{ NID_proxyCertInfo, 0, ASN1_ITEM_ref(PROXY_CERT_INFO_EXTENSION),
+CONST_X509V3_EXT_METHOD_item(v3_pci,
+	 NID_proxyCertInfo, 0, ASN1_ITEM_ref(PROXY_CERT_INFO_EXTENSION),
 	  0,0,0,0,
 	  0,0,
 	  NULL, NULL,
-	  (X509V3_EXT_I2R)i2r_pci,
-	  (X509V3_EXT_R2I)r2i_pci,
-	  NULL,
-	};
+	  OPERA_I2R_DECLARE((X509V3_EXT_I2R)i2r_pci),
+	  OPERA_R2I_DECLARE((X509V3_EXT_R2I)r2i_pci),
+	  NULL
+	  )
 
+#ifndef OPERA_SMALL_VERSION
 static int i2r_pci(X509V3_EXT_METHOD *method, PROXY_CERT_INFO_EXTENSION *pci,
 	BIO *out, int indent)
 	{
@@ -78,7 +81,7 @@
 	{
 	int free_policy = 0;
 
-	if (strcmp(val->name, "language") == 0)
+	if (op_strcmp(val->name, "language") == 0)
 		{
 		if (*language)
 			{
@@ -93,7 +96,7 @@
 			return 0;
 			}
 		}
-	else if (strcmp(val->name, "pathlen") == 0)
+	else if (op_strcmp(val->name, "pathlen") == 0)
 		{
 		if (*pathlen)
 			{
@@ -108,7 +111,7 @@
 			return 0;
 			}
 		}
-	else if (strcmp(val->name, "policy") == 0)
+	else if (op_strcmp(val->name, "policy") == 0)
 		{
 		unsigned char *tmp_data = NULL;
 		long val_len;
@@ -123,7 +126,7 @@
 				}
 			free_policy = 1;
 			}
-		if (strncmp(val->value, "hex:", 4) == 0)
+		if (op_strncmp(val->value, "hex:", 4) == 0)
 			{
 			unsigned char *tmp_data2 =
 				string_to_hex(val->value + 4, &val_len);
@@ -135,12 +138,12 @@
 				goto err;
 				}
 
-			tmp_data = OPENSSL_realloc((*policy)->data,
+			tmp_data = (unsigned char *) OPENSSL_realloc((*policy)->data,
 				(*policy)->length + val_len + 1);
 			if (tmp_data)
 				{
 				(*policy)->data = tmp_data;
-				memcpy(&(*policy)->data[(*policy)->length],
+				op_memcpy(&(*policy)->data[(*policy)->length],
 					tmp_data2, val_len);
 				(*policy)->length += val_len;
 				(*policy)->data[(*policy)->length] = '\0';
@@ -157,9 +160,10 @@
 				}
 			OPENSSL_free(tmp_data2);
 			}
+#ifndef OPERA_SMALL_VERSION
 		else if (strncmp(val->value, "file:", 5) == 0)
 			{
-			unsigned char buf[2048];
+			unsigned char buf[2048];  /* ARRAY OK 2007-11-07 yngve UNUSED */
 			int n;
 			BIO *b = BIO_new_file(val->value + 5, "r");
 			if (!b)
@@ -180,7 +184,7 @@
 					break;
 
 				(*policy)->data = tmp_data;
-				memcpy(&(*policy)->data[(*policy)->length],
+				op_memcpy(&(*policy)->data[(*policy)->length],
 					buf, n);
 				(*policy)->length += n;
 				(*policy)->data[(*policy)->length] = '\0';
@@ -194,15 +198,16 @@
 				goto err;
 				}
 			}
-		else if (strncmp(val->value, "text:", 5) == 0)
+#endif // !OPERA_SMALL_VERSION
+		else if (op_strncmp(val->value, "text:", 5) == 0)
 			{
-			val_len = strlen(val->value + 5);
-			tmp_data = OPENSSL_realloc((*policy)->data,
+			val_len = op_strlen(val->value + 5);
+			tmp_data = (unsigned char *) OPENSSL_realloc((*policy)->data,
 				(*policy)->length + val_len + 1);
 			if (tmp_data)
 				{
 				(*policy)->data = tmp_data;
-				memcpy(&(*policy)->data[(*policy)->length],
+				op_memcpy(&(*policy)->data[(*policy)->length],
 					val->value + 5, val_len);
 				(*policy)->length += val_len;
 				(*policy)->data[(*policy)->length] = '\0';
@@ -326,3 +331,4 @@
 	sk_CONF_VALUE_pop_free(vals, X509V3_conf_free);
 	return pci;
 	}
+#endif // !OPERA_SMALL_VERSION
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_pcia.c openssl-1.0.0q/crypto/x509v3/v3_pcia.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_pcia.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_pcia.c	2017-04-25 16:23:40.883797519 +0200
@@ -37,19 +37,20 @@
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
-ASN1_SEQUENCE(PROXY_POLICY) =
-	{
-	ASN1_SIMPLE(PROXY_POLICY,policyLanguage,ASN1_OBJECT),
+ASN1_SEQUENCE(PROXY_POLICY) 
+	ASN1_SIMPLE(PROXY_POLICY,policyLanguage,ASN1_OBJECT)
 	ASN1_OPT(PROXY_POLICY,policy,ASN1_OCTET_STRING)
-} ASN1_SEQUENCE_END(PROXY_POLICY)
+ASN1_SEQUENCE_END(PROXY_POLICY)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(PROXY_POLICY)
+#endif
 
-ASN1_SEQUENCE(PROXY_CERT_INFO_EXTENSION) =
-	{
-	ASN1_OPT(PROXY_CERT_INFO_EXTENSION,pcPathLengthConstraint,ASN1_INTEGER),
+ASN1_SEQUENCE(PROXY_CERT_INFO_EXTENSION) 
+	ASN1_OPT(PROXY_CERT_INFO_EXTENSION,pcPathLengthConstraint,ASN1_INTEGER)
 	ASN1_SIMPLE(PROXY_CERT_INFO_EXTENSION,proxyPolicy,PROXY_POLICY)
-} ASN1_SEQUENCE_END(PROXY_CERT_INFO_EXTENSION)
+ASN1_SEQUENCE_END(PROXY_CERT_INFO_EXTENSION)
 
-IMPLEMENT_ASN1_FUNCTIONS(PROXY_CERT_INFO_EXTENSION)
+IMPLEMENT_ASN1_FUNCTIONS32(PROXY_CERT_INFO_EXTENSION)
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_pcons.c openssl-1.0.0q/crypto/x509v3/v3_pcons.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_pcons.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_pcons.c	2017-04-25 16:23:40.883797519 +0200
@@ -56,45 +56,49 @@
  *
  */
 
-
-#include <stdio.h>
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/conf.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 static STACK_OF(CONF_VALUE) *
 i2v_POLICY_CONSTRAINTS(const X509V3_EXT_METHOD *method, void *bcons,
 		       STACK_OF(CONF_VALUE) *extlist);
+
+#ifndef OPERA_SMALL_VERSION
 static void *v2i_POLICY_CONSTRAINTS(const X509V3_EXT_METHOD *method,
 				    X509V3_CTX *ctx,
 				    STACK_OF(CONF_VALUE) *values);
+#endif // !OPERA_SMALL_VERSION
 
-const X509V3_EXT_METHOD v3_policy_constraints = {
+CONST_X509V3_EXT_METHOD_item(v3_policy_constraints ,
 NID_policy_constraints, 0,
 ASN1_ITEM_ref(POLICY_CONSTRAINTS),
 0,0,0,0,
 0,0,
 i2v_POLICY_CONSTRAINTS,
-v2i_POLICY_CONSTRAINTS,
+OPERA_V2I_DECLARE(v2i_POLICY_CONSTRAINTS),
 NULL,NULL,
 NULL
-};
+)
 
-ASN1_SEQUENCE(POLICY_CONSTRAINTS) = {
-	ASN1_IMP_OPT(POLICY_CONSTRAINTS, requireExplicitPolicy, ASN1_INTEGER,0),
+ASN1_SEQUENCE(POLICY_CONSTRAINTS) 
+	ASN1_IMP_OPT(POLICY_CONSTRAINTS, requireExplicitPolicy, ASN1_INTEGER,0)
 	ASN1_IMP_OPT(POLICY_CONSTRAINTS, inhibitPolicyMapping, ASN1_INTEGER,1)
-} ASN1_SEQUENCE_END(POLICY_CONSTRAINTS)
+ASN1_SEQUENCE_END(POLICY_CONSTRAINTS)
 
-IMPLEMENT_ASN1_ALLOC_FUNCTIONS(POLICY_CONSTRAINTS)
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
+IMPLEMENT_ASN1_ALLOC_FUNCTIONS2(POLICY_CONSTRAINTS)
+#endif
 
 
 static STACK_OF(CONF_VALUE) *
 i2v_POLICY_CONSTRAINTS(const X509V3_EXT_METHOD *method, void *a,
 		       STACK_OF(CONF_VALUE) *extlist)
 {
-	POLICY_CONSTRAINTS *pcons = a;
+	POLICY_CONSTRAINTS *pcons = (POLICY_CONSTRAINTS *) a;
 	X509V3_add_value_int("Require Explicit Policy",
 			pcons->requireExplicitPolicy, &extlist);
 	X509V3_add_value_int("Inhibit Policy Mapping",
@@ -102,6 +106,7 @@
 	return extlist;
 }
 
+#ifndef OPERA_SMALL_VERSION
 static void *v2i_POLICY_CONSTRAINTS(const X509V3_EXT_METHOD *method,
 				    X509V3_CTX *ctx,
 				    STACK_OF(CONF_VALUE) *values)
@@ -137,4 +142,5 @@
 	POLICY_CONSTRAINTS_free(pcons);
 	return NULL;
 }
+#endif
 
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_pku.c openssl-1.0.0q/crypto/x509v3/v3_pku.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_pku.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_pku.c	2017-04-25 16:23:40.884798763 +0200
@@ -56,30 +56,35 @@
  *
  */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/asn1.h>
 #include <openssl/asn1t.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
 static int i2r_PKEY_USAGE_PERIOD(X509V3_EXT_METHOD *method, PKEY_USAGE_PERIOD *usage, BIO *out, int indent);
 /*
 static PKEY_USAGE_PERIOD *v2i_PKEY_USAGE_PERIOD(X509V3_EXT_METHOD *method, X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *values);
 */
-const X509V3_EXT_METHOD v3_pkey_usage_period = {
+CONST_X509V3_EXT_METHOD_item(v3_pkey_usage_period,
 NID_private_key_usage_period, 0, ASN1_ITEM_ref(PKEY_USAGE_PERIOD),
 0,0,0,0,
 0,0,0,0,
 (X509V3_EXT_I2R)i2r_PKEY_USAGE_PERIOD, NULL,
 NULL
-};
+)
 
-ASN1_SEQUENCE(PKEY_USAGE_PERIOD) = {
-	ASN1_IMP_OPT(PKEY_USAGE_PERIOD, notBefore, ASN1_GENERALIZEDTIME, 0),
+ASN1_SEQUENCE(PKEY_USAGE_PERIOD) 
+	ASN1_IMP_OPT(PKEY_USAGE_PERIOD, notBefore, ASN1_GENERALIZEDTIME, 0)
 	ASN1_IMP_OPT(PKEY_USAGE_PERIOD, notAfter, ASN1_GENERALIZEDTIME, 1)
-} ASN1_SEQUENCE_END(PKEY_USAGE_PERIOD)
+ASN1_SEQUENCE_END(PKEY_USAGE_PERIOD)
 
+#ifndef OPERA_SMALL_VERSION
 IMPLEMENT_ASN1_FUNCTIONS(PKEY_USAGE_PERIOD)
+#endif
 
 static int i2r_PKEY_USAGE_PERIOD(X509V3_EXT_METHOD *method,
 	     PKEY_USAGE_PERIOD *usage, BIO *out, int indent)
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_pmaps.c openssl-1.0.0q/crypto/x509v3/v3_pmaps.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_pmaps.c	2015-01-15 15:43:14.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_pmaps.c	2017-04-25 16:23:40.885798611 +0200
@@ -56,52 +56,56 @@
  *
  */
 
-
-#include <stdio.h>
-#include "cryptlib.h"
+#include <openssl/cryptlib.h>
 #include <openssl/asn1t.h>
 #include <openssl/conf.h>
 #include <openssl/x509v3.h>
+#include "modules/libopeay/libopeay_arrays.h"
 
+#ifndef OPERA_SMALL_VERSION
 static void *v2i_POLICY_MAPPINGS(const X509V3_EXT_METHOD *method,
 				 X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *nval);
+#endif // !OPERA_SMALL_VERSION
+
 static STACK_OF(CONF_VALUE) *
 i2v_POLICY_MAPPINGS(const X509V3_EXT_METHOD *method, void *pmps,
 		    STACK_OF(CONF_VALUE) *extlist);
 
-const X509V3_EXT_METHOD v3_policy_mappings = {
+CONST_X509V3_EXT_METHOD_item(v3_policy_mappings ,
 	NID_policy_mappings, 0,
 	ASN1_ITEM_ref(POLICY_MAPPINGS),
 	0,0,0,0,
 	0,0,
 	i2v_POLICY_MAPPINGS,
-	v2i_POLICY_MAPPINGS,
+	OPERA_V2I_DECLARE(v2i_POLICY_MAPPINGS),
 	0,0,
 	NULL
-};
+)
 
-ASN1_SEQUENCE(POLICY_MAPPING) = {
-	ASN1_SIMPLE(POLICY_MAPPING, issuerDomainPolicy, ASN1_OBJECT),
+ASN1_SEQUENCE(POLICY_MAPPING) 
+	ASN1_SIMPLE(POLICY_MAPPING, issuerDomainPolicy, ASN1_OBJECT)
 	ASN1_SIMPLE(POLICY_MAPPING, subjectDomainPolicy, ASN1_OBJECT)
-} ASN1_SEQUENCE_END(POLICY_MAPPING)
+ASN1_SEQUENCE_END(POLICY_MAPPING)
 
-ASN1_ITEM_TEMPLATE(POLICY_MAPPINGS) = 
+ASN1_ITEM_TEMPLATE(POLICY_MAPPINGS)
 	ASN1_EX_TEMPLATE_TYPE(ASN1_TFLG_SEQUENCE_OF, 0, POLICY_MAPPINGS,
 								POLICY_MAPPING)
 ASN1_ITEM_TEMPLATE_END(POLICY_MAPPINGS)
 
-IMPLEMENT_ASN1_ALLOC_FUNCTIONS(POLICY_MAPPING)
+#if !defined OPERA_SMALL_VERSION || defined OPERA_NEED_POLICY_FUN
+IMPLEMENT_ASN1_ALLOC_FUNCTIONS2(POLICY_MAPPING)
+#endif
 
 
 static STACK_OF(CONF_VALUE) *
 i2v_POLICY_MAPPINGS(const X509V3_EXT_METHOD *method, void *a,
 		    STACK_OF(CONF_VALUE) *ext_list)
 {
-	POLICY_MAPPINGS *pmaps = a;
+	POLICY_MAPPINGS *pmaps = (POLICY_MAPPINGS *) a;
 	POLICY_MAPPING *pmap;
 	int i;
-	char obj_tmp1[80];
-	char obj_tmp2[80];
+	char obj_tmp1[80]; /* ARRAY OK 2009-05-25 yngve */
+	char obj_tmp2[80]; /* ARRAY OK 2009-05-25 yngve */
 	for(i = 0; i < sk_POLICY_MAPPING_num(pmaps); i++) {
 		pmap = sk_POLICY_MAPPING_value(pmaps, i);
 		i2t_ASN1_OBJECT(obj_tmp1, 80, pmap->issuerDomainPolicy);
@@ -111,6 +115,7 @@
 	return ext_list;
 }
 
+#ifndef OPERA_SMALL_VERSION
 static void *v2i_POLICY_MAPPINGS(const X509V3_EXT_METHOD *method,
 				 X509V3_CTX *ctx, STACK_OF(CONF_VALUE) *nval)
 {
@@ -153,3 +158,4 @@
 	}
 	return pmaps;
 }
+#endif
diff -Naur openssl-1.0.0q.orig/crypto/x509v3/v3_prn.c openssl-1.0.0q/crypto/x509v3/v3_prn.c
--- openssl-1.0.0q.orig/crypto/x509v3/v3_prn.c	2015-01-15 15:43:49.000000000 +0100
+++ openssl-1.0.0q/crypto/x509v3/v3_prn.c	2017-04-25 16:23:40.885798611 +0200
@@ -57,8 +57,10 @@
  */
 /* X509 v3 extension utilities */
 
+#ifndef OPERA_SMALL_VERSION
 #include <stdio.h>
-#include "cryptlib.h"
+#endif /* !OPERA_SMALL_VERSION */
+#include <openssl/cryptlib.h>
 #include <openssl/conf.h>
 #include <openssl/x509v3.h>
 
@@ -89,7 +91,7 @@
 		else {
 			int len;
 			char *tmp;
-			len = strlen(nval->value)+1;
+			len = op_strlen(nval->value)+1;
 			tmp = OPENSSL_malloc(len);
 			if (tmp)
 			{
@@ -133,7 +135,7 @@
 		{
 			int len;
 			char *tmp;
-			len = strlen(value)+1;
+			len = op_strlen(value)+1;
 			tmp = OPENSSL_malloc(len);
 			if (tmp)
 			{
@@ -157,11 +159,12 @@
 	err:
 		sk_CONF_VALUE_pop_free(nval, X509V3_conf_free);
 		if(value) OPENSSL_free(value);
-		if(method->it) ASN1_item_free(ext_str, ASN1_ITEM_ptr(method->it));
+		if(method->it) ASN1_item_free((ASN1_VALUE *) ext_str, ASN1_ITEM_ptr(method->it));
 		else method->ext_free(ext_str);
 		return ok;
 }
 
+#ifndef OPERA_SMALL_VERSION
 int X509V3_extensions_print(BIO *bp, char *title, STACK_OF(X509_EXTENSION) *exts, unsigned long flag, int indent)
 {
 	int i, j;
@@ -194,6 +197,7 @@
 		}
 	return 1;
 }
+#endif
 
 static int unknown_ext_print(BIO *out, X509_EXTENSION *ext, unsigned long flag, int indent, int supported)
 {
@@ -201,6 +205,7 @@
 
 		case X509V3_EXT_DEFAULT:
 		return 0;
+#ifndef OPERA_SMALL_VERSION
 
 		case X509V3_EXT_ERROR_UNKNOWN:
 		if(supported)
@@ -214,6 +219,7 @@
 				ext->value->data, ext->value->length, indent, -1);
 		case X509V3_EXT_DUMP_UNKNOWN:
 			return BIO_dump_indent(out, (char *)ext->value->data, ext->value->length, indent);
+#endif
 
 		default:
 		return 1;
@@ -221,6 +227,7 @@
 }
 	
 
+#ifndef OPERA_SMALL_VERSION
 #ifndef OPENSSL_NO_FP_API
 int X509V3_EXT_print_fp(FILE *fp, X509_EXTENSION *ext, int flag, int indent)
 {
@@ -232,3 +239,4 @@
 	return ret;
 }
 #endif
+#endif
